// B+   
//     2-3  1-2  
//          
//     IP ,    .
//   count  ,      
//
//   
//
// 1)            (  )
//    .      ,    
// 2)        

#include<stdio.h>
#include<stdlib.h>
#include<memory.h>
#include<conio.h>

#define NODE_LIMIT 2000		//    
#define LIST_LIMIT 2000		//    
#define CHECK_SIZE 1000		//   
#define NODE_SIZE 7			//  
#define LIST_SIZE 7		//   (     )
#define BINARY_LIST_FIND		//   
#define BINARY_NODE_FIND		//   
#define NODE_VOID			//       
#define LIST_VOID	-1		//       

#if LIST_SIZE<2 || NODE_SIZE<2
#error 1
#endif

struct node_st; struct list_st; union ref_type{node_st *pnode; list_st *plist;}; //  
struct cell_st{ int v; ref_type p;};					//!<  
struct node_st{
#ifndef NODE_VOID
	int count; 
#endif
	cell_st arr[NODE_SIZE];
};	//!<   
struct list_st{
#ifndef LIST_VOID
	int count;
#endif 
	int v[LIST_SIZE];
};	//!<  
// v   
// p   
// count  

ref_type tree_root;	//!<    
int tree_h;		//!<  


//=====  =====

//!   
node_st* NewNode()
{
	node_st *t=new node_st;
	memset(t,0,sizeof(node_st));
	return t;
}

//!   
list_st* NewList()
{
	list_st *t=new list_st;
#ifdef LIST_VOID
	for(int n=0; n<LIST_SIZE; n++) t->v[n]=LIST_VOID;
#else
	memset(t,0,sizeof(list_st));
#endif
	return t;
}

//!  
void FreeNode(node_st *node)
{
	delete node;
}

//!  
void FreeList(list_st *list)
{
	delete list;
}


//!  
void Init()
{
	tree_root.plist=0; tree_h=0; 
}


//=====    =====

//!     
int GetNodeCount(node_st *node)
{
#ifdef NODE_VOID
	for(int n=0; n<NODE_SIZE; n++) if(!node->arr[n].p.pnode) break;
	return n;
#else
	return node->count;
#endif
}

//!     
int GetListCount(list_st* list)
{
#ifdef LIST_VOID
	for(int n=0; n<LIST_SIZE; n++) if(list->v[n]==LIST_VOID) break;
	return n;
#else
	return list->count;
#endif
}


//!         
//! \param list  
//! \param value  
//! \param coincidence =true   , =false   
int FindInList(list_st *list,int value,bool coincidence)
{
#ifdef BINARY_LIST_FIND
	int a,b,c;
#ifdef LIST_VOID
	a=0;
	b=LIST_SIZE-1;
	while(a<=b) {
		c=(a+b)/2;
		if(list->v[c]!=LIST_VOID) a=c+1; else b=c-1;	
	}
#else
	b=list->count-1;
#endif
	a=0;
	while(a<=b) {
		c=(a+b)/2;
		if(list->v[c]==value) return coincidence?c:-1;
		if(list->v[c]<value) a=c+1; else b=c-1;	
	}
	return coincidence?-1:a;
#else
	int i;
	for(i=0; i<list->count; i++) {
		if(list->v[i]==value) return coincidence?i:-1;
		if(list->v[i]>value) break;
	} 
	return coincidence?-1:i;
#endif
}


//!         
//! \param node  
//! \param value  
//! \param no_coincidence =true      
int FindInNode(node_st *node,int value,bool no_coincidence)
{
#ifdef BINARY_NODE_FIND
	int a,b,c;
#ifdef NODE_VOID
	a=0;
	b=NODE_SIZE-1;
	while(a<=b) {
		c=(a+b)/2;
		if(node->arr[c].p.pnode) a=c+1; else b=c-1;	
	}
#else
	b=node->count-1;
#endif
	a=0;
	while(a<=b) {
		c=(a+b)/2;
		if(no_coincidence && node->arr[c].v==value) return -1;
		if(node->arr[c].v<=value) a=c+1; else b=c-1;	
	}
	return a;
#else
	int i;
	for(i=0; i<node->count; i++) {	
		if(no_coincidence && value==node->arr[i].v) return -1;
		if(value<node->arr[i].v) break;
	}
	return i;
#endif
}

//!  
//! \param list   
//! \param sl  ,     
//! \result   
inline list_st* SplitList(list_st *list,int slack)
{
	int i;
	list_st *t=NewList();
	for(i=0; i<LIST_SIZE/2; i++) t->v[i]=list->v[i+(LIST_SIZE+1)/2];
	t->v[i++]=slack; 
#ifdef LIST_VOID
	for(i=(LIST_SIZE+1)/2; i<LIST_SIZE; i++) list->v[i]=LIST_VOID;
#else
	t->count=i;
	list->count=(LIST_SIZE+1)/2;
#endif
	return t;
}

//!  
//! \param node   
//! \param sl  ,     
//! \result   
inline node_st* SplitNode(node_st *node,cell_st slack)
{
	int i;
	node_st *t=NewNode();
	for(i=0; i<NODE_SIZE/2; i++) t->arr[i]=node->arr[i+(NODE_SIZE+1)/2];
	t->arr[i++]=slack; 
#ifdef NODE_VOID
	for(i=(NODE_SIZE+1)/2; i<NODE_SIZE; i++) node->arr[i].p.pnode=0;
#else
	node->count=(NODE_SIZE+1)/2;
	t->count=i;
#endif
	return t;
}


//!    
//! \param list   
//! \param value  
//! \result  ,     
inline list_st* InsertToList(list_st *list,int value)
{
	int i,n; int slack;
	i=FindInList(list,value,false); if(i<0) return 0;
	slack=list->v[LIST_SIZE-1];
#ifdef LIST_VOID
	n=LIST_SIZE-1;
#else
	n=list->count; if(n==LIST_SIZE) n--;
#endif
	for(; n>i; n--) list->v[n]=list->v[n-1];
	if(i<LIST_SIZE) list->v[i]=value; else slack=value;
#ifdef LIST_VOID
	if(slack==LIST_VOID) return 0;
#else
	list->count++;
	if(list->count<=LIST_SIZE) return 0;
#endif
	return SplitList(list,slack);
}

//!    
//! \param node    
//! \param i      
//! \param ref  
//! \param min   
//! \result !=VOID   ,     
inline node_st* InsertToNode(node_st *node,int i,node_st *ref,int min)
{
	int n;
	cell_st slack_n;
	slack_n=node->arr[NODE_SIZE-1];
#ifdef NODE_VOID
	n=NODE_SIZE-1;
#else
	n=node->count; if(n==NODE_SIZE) n--;
#endif
	for(; n>i+1; n--) node->arr[n]=node->arr[n-1];
	if(i<NODE_SIZE-1) node->arr[i+1].v=min,node->arr[i+1].p.pnode=ref;
	else slack_n.p.pnode=ref,slack_n.v=min;
#ifdef NODE_VOID
	if(!slack_n.p.pnode) return 0;
#else
	node->count++;
	if(node->count<=NODE_SIZE) return 0;
#endif
	return SplitNode(node,slack_n);
}

//!   
//! \param i1   ( )
//! \param i2   ( )
inline void MergeList(list_st *list1,list_st *list2)
{
	int n,m;
	n=GetListCount(list1);
#ifdef LIST_VOID
	for(m=0; m<LIST_SIZE && n<LIST_SIZE; m++,n++) {
		if(list2->v[m]==LIST_VOID) break;
		list1->v[n]=list2->v[m];
	}
#else
	for(m=0; m<list2->count && n<LIST_SIZE; m++,n++) list1->v[n]=list2->v[m];
	list1->count=n;
#endif
	FreeList(list2);
}

//!   
//! \param i1   ( )
//! \param i2   ( )
inline void MergeNode(node_st *node1,node_st *node2)
{
	int n,m;
	n=GetNodeCount(node1);
#ifdef NODE_VOID
	for(m=0; m<NODE_SIZE && n<NODE_SIZE; m++,n++) {
		if(!node2->arr[m].p.pnode) break;
		node1->arr[n]=node2->arr[m];
	}
#else
	for(m=0; m<node2->count && n<NODE_SIZE; m++,n++) node1->arr[n]=node2->arr[m];
	node1->count=n;
#endif
	FreeNode(node2);
}


//!    
//! \param node   
//! \param i   
inline RemoveFromNode(node_st *node,int i)
{
	int n;
#ifdef NODE_VOID
	for(n=i; n<NODE_SIZE-1; n++) node->arr[n]=node->arr[n+1];
	node->arr[NODE_SIZE-1].p.pnode=0;
#else
	for(n=i; n<node->count; n++) node->arr[n]=node->arr[n+1];
	node->count--;
#endif
}

//!   
inline void PourNodeL(node_st *node1,node_st *node2)
{
#ifdef NODE_VOID
	int n=GetNodeCount(node1);
	if(n>NODE_SIZE) _asm { int 3 }
	node1->arr[n]=node2->arr[0];
#else
	if(node->count>=NODE_SIZE) _asm { int 3 }
	node1->arr[node1->count++]=node2->arr[0];
#endif
	RemoveFromNode(node2,0);
}

//!   
inline void PourNodeR(node_st *node1,node_st *node2)
{
	int n;
#ifdef NODE_VOID
	n=GetNodeCount(node1)-1;
#else
	n=--node1->count;
#endif
	if(n<0) _asm { int 3 }
	InsertToNode(node2,-1,node1->arr[n].p.pnode,node1->arr[n].v);
#ifdef NODE_VOID
	node1->arr[n].p.pnode=0;
#endif
}

//!   
inline void PourListL(list_st *list1,list_st *list2)
{
#ifdef LIST_VOID
	int m,n;
	n=GetListCount(list1);
	if(n>=LIST_SIZE) _asm { int 3 }
	list1->v[n]=list2->v[0];
	for(m=1; m<LIST_SIZE; m++) list2->v[m-1]=list2->v[m];
	list2->v[LIST_SIZE-1]=LIST_VOID;
#else
	int n;
	list1->v[list1->count++]=list2->v[0];
	for(n=1; n<list2->count; n++) list2->v[n-1]=list2->v[n];
	list2->count--;
#endif
}

//!   
inline void PourListR(list_st *list1,list_st *list2)
{
	int n;
#ifdef LIST_VOID
	if(list2->v[LIST_SIZE-1]!=LIST_VOID || list1->v[0]==LIST_VOID) _asm { int 3 }
	for(n=LIST_SIZE-1;n;n--) list2->v[n]=list2->v[n-1]; 
	n=GetListCount(list1)-1;
	list2->v[0]=list1->v[n];
	list1->v[n]=LIST_VOID;
#else
	for(n=list2->count;n;n--) list2->v[n]=list2->v[n-1]; 
	list1->count--; list2->count++;
	list2->v[0]=list1->v[list1->count];	
#endif
}

//!     ,    
//! \param node   
//! \param depth 
//! \param i1     (   )
//! \param i2     
bool GetNeighbour(node_st *node,int depth,int *i1,int *i2)
{
	int mask=0;
	ref_type ref1,ref2;
	int count1,count2;
	if(*i1>0) mask|=1;
#ifdef NODE_VOID
	if(*i1<NODE_SIZE-1 && node->arr[1+*i1].p.pnode) mask|=2;
#else
	if(*i1<nodes[tree_index].count-1) mask|=2;
#endif
	switch(mask) {
	case 0: return true;
	case 1: *i2=(*i1)--; break;
	case 2: *i2=(*i1)+1; break;
	case 3: 
		ref1=node->arr[(*i1)-1].p;
		ref2=node->arr[(*i1)+1].p;
		if(depth==tree_h-1) count1=GetListCount(ref1.plist),count2=GetListCount(ref2.plist);
		else count1=GetNodeCount(ref1.pnode),count2=GetNodeCount(ref2.pnode);
		if(count1<count2) *i2=(*i1)+1; else *i2=(*i1)--; break;
	}
	return false;
}


//=====     =====

//!  ,  
//! \param node  
//! \param depth 
void Show(ref_type node,int depth,int nn)
{
	int n,m;
	for(n=0; n<depth*2; n++) putchar(' ');
	if(depth==tree_h) {
		printf("l%d:",nn);
#ifdef LIST_VOID
		for(n=0; n<LIST_SIZE; n++) if(node.plist->v[n]!=LIST_VOID) printf(" %d",node.plist->v[n]); else break;
#else
		for(n=0; n<node.plist->count; n++) printf(" %d",node.plist->v[n]);
#endif
		putchar('\n');
		return;
	}
	printf("n%d: ",nn);
#ifdef NODE_VOID
	for(m=0; m<NODE_SIZE; m++) {
		if(!node.pnode->arr[m].p.pnode) break;
		//if(m) 
			printf("[%d]",node.pnode->arr[m].v);
		printf("%d",node.pnode->arr[m].p);
	}
	putchar('\n');
	for(n=0; n<NODE_SIZE; n++) if(node.pnode->arr[n].p.pnode) Show(node.pnode->arr[n].p,depth+1,n); else break;
#else
	for(m=0; m<node.pnode->count; m++) {
		if(m) printf("[%d]",node.pnode->arr[m].v);
		printf("%d",node.pnode->arr[m].p);
	}
	putchar('\n');
	for(n=0; n<node.pnode->count; n++) Show(node.pnode->arr[n].p,depth+1);
#endif
}

//!   (        )
//!       ,     
//! \param node   
//! \param i1    (   )
//! \param depth 
void Balance(node_st *node,int i1,int depth)
{
	ref_type ref1,ref2;
	int count1,count2,i2;
	//      (    )
#if NODE_SIZE<3 // 1-2 
	ref1=node->arr[i1].p;
	if(depth==tree_h-1 && !ref1.plist->count || depth<tree_h-1 && !ref1.pnode->count) {
		RemoveFromNode(node,i1);
		if(depth==tree_h-1) FreeList(ref1.plist); else FreeNode(ref1.pnode);
		return;
	}
#endif
	if(GetNeighbour(node,depth,&i1,&i2)) return;
	ref1=node->arr[i1].p;
	ref2=node->arr[i2].p;
	if(depth==tree_h-1) { //   ,      
		count1=GetListCount(ref1.plist);
		count2=GetListCount(ref2.plist);
		if(count1+count2<=LIST_SIZE) { //    
			MergeList(ref1.plist,ref2.plist);
			RemoveFromNode(node,i2);
#if LIST_SIZE==2
			node->arr[i1].v=ref1.plist->v[0];
#endif
		} else
		if(abs(count1-count2)>1) { //  
			if(count1>count2) PourListR(ref1.plist,ref2.plist); else PourListL(ref1.plist,ref2.plist);
			node->arr[i2].v=ref2.plist->v[0];
		}
	} else {
		count1=GetNodeCount(ref1.pnode);
		count2=GetNodeCount(ref2.pnode);
		if(count1+count2<=NODE_SIZE) {	//  
			MergeNode(ref1.pnode,ref2.pnode);
			RemoveFromNode(node,i2);
#if NODE_SIZE<3	// 1-2 
			node->arr[i1].v=ref1.pnode->arr[0].v;
#endif
		} else
		if(abs(count1-count2)>1) { //  
			if(count1>count2) PourNodeR(ref1.pnode,ref2.pnode); else PourNodeL(ref1.pnode,ref2.pnode);
			node->arr[i2].v=ref2.pnode->arr[0].v;
		}
	}
}


//!  ,  
//! \param node    
//! \param depth 
//! \param value  
//! \result     
node_st* InsertSub(ref_type node,int depth,int value)
{
	static int min1,min2;
	int i; ref_type p;
	if(depth==tree_h) {	
		//     
		p.plist=InsertToList(node.plist,value); 
		min1=node.plist->v[0];
		if(!p.plist) return 0;
		min2=p.plist->v[0];
		goto exit;
	}
	//           (    )
	min1=node.pnode->arr[0].v;
	i=FindInNode(node.pnode,value,true); if(i<0) return 0;
	if(i) i--;
	p.pnode=InsertSub(node.pnode->arr[i].p,depth+1,value); //   
	node.pnode->arr[i].v=min1;
	min1=node.pnode->arr[0].v;
	if(!p.pnode) return 0;
	//     
	p.pnode=InsertToNode(node.pnode,i,p.pnode,min2); 
	if(!p.pnode) return 0;
	min2=p.pnode->arr[0].v;
exit:
	if(depth) return p.pnode;	//   ,    .
	node_st *t=NewNode(); tree_h++;
#ifndef NODE_VOID
	t->count=2;
#endif
	t->arr[0].p=tree_root;
	t->arr[1].p=p;
	t->arr[0].v=min1;
	t->arr[1].v=min2;
	tree_root.pnode=t;
	return 0;
}


//!  ,  
//! \param node 
//! \param depth 
//! \param value 
void RemoveSub(ref_type node,int depth,int value)
{
	static int min;
	int n,i1;
	if(depth==tree_h) {	
		//   ,    
		n=FindInList(node.plist,value,true);
		if(n!=VOID) { 
#ifdef LIST_VOID
			for(;n<LIST_SIZE-1; n++) node.plist->v[n]=node.plist->v[n+1]; 
			node.plist->v[LIST_SIZE-1]=LIST_VOID;
#else
			for(;n<node.plist->count-1; n++) node.plist->v[n]=node.plist->v[n+1]; 
			node.plist->count--;
#endif
		}
		min=node.plist->v[0];
		return;
	}
	//     ,     
	i1=FindInNode(node.pnode,value,false); //if(i1==VOID) return;
	i1--; if(i1<0) return;
	RemoveSub(node.pnode->arr[i1].p,depth+1,value); //   
	node.pnode->arr[i1].v=min;
	Balance(node.pnode,i1,depth);
	min=node.pnode->arr[0].v;
}


//!  , 
//! \param node     
//! \param depth  
void Drop(ref_type node,int depth)
{
	int n;
	if(depth==tree_h) {
		delete node.plist;
		return;
	}
#ifdef NODE_VOID
	for(n=0; n<NODE_SIZE; n++) 
		if(node.pnode->arr[n].p.pnode) Drop(node.pnode->arr[n].p,depth+1);
		else break;
#else
	for(n=0; n<node.pnode->count; n++) Drop(node.pnode->arr[n].p,depth+1);
#endif
	delete node.pnode;
}

//=====   (   ) =====

//!  
void Show()
{
	printf("[show]\n");
	Show(tree_root,0,0);
}

//!    
//! \param value  
void Insert(int value)
{
	printf("insert: %d\n",value);
	if(!tree_root.plist) {	//    -   
		tree_root.plist=NewList(); tree_h=0;
#ifndef LIST_VOID
		tree_root.plist->count=1;
#endif
		tree_root.plist->v[0]=value;
		return;
	}
	InsertSub(tree_root,0,value); 
}

//!   
//! \param value  
void Remove(int value)
{
	node_st *t;
	printf("remove: %d\n",value);
	RemoveSub(tree_root,0,value);
	while(tree_h>0) { //      ,   
#ifdef NODE_VOID
		if(tree_root.pnode->arr[1].p.pnode) break;
#else
		if(tree_root.pnode->count!=1) break;
#endif
		t=tree_root.pnode; tree_root=tree_root.pnode->arr[0].p;
		FreeNode(t);
		tree_h--;
	}
}


//!  
void DropTree()
{
	Drop(tree_root,0);
	Init();
}


//=====    ======

//     
enum MapCode{
MAPCODE_FREE	=0,	//  
MAPCODE_USE		=1,	//  
MAPCODE_USEOK	=2,	//     
MAPCODE_ERR		=3	//  ,    
};

MapCode map[CHECK_SIZE]; //!<     

//!     ,  
//! \param node  
//! \param depth 
void CheckMap(ref_type node,int depth)
{
	int n,v;
	if(depth==tree_h) {
#ifdef LIST_VOID
		for(n=0; n<LIST_SIZE; n++) { 
			v=node.plist->v[n]; if(v==LIST_VOID) break;
			map[v]=map[v]==MAPCODE_USE?MAPCODE_USEOK:MAPCODE_ERR;
		}
#else
		for(n=0; n<node.plist->count; n++) { 
			v=node.plist->v[n];
			map[v]=map[v]==MAPCODE_USE?MAPCODE_USEOK:MAPCODE_ERR;
		}
#endif
		return;
	}
#ifdef NODE_VOID
	for(n=0; n<NODE_SIZE; n++) if(node.pnode->arr[n].p.pnode) CheckMap(node.pnode->arr[n].p,depth+1); else break;
#else
	for(n=0; n<node.pnode->count; n++) CheckMap(node.pnode->arr[n].p,depth+1);
#endif
}

//!     
//!   
void CheckMap()
{
	int n;
	CheckMap(tree_root,0);
	for(n=0; n<CHECK_SIZE; n++) switch(map[n]) {
	case MAPCODE_FREE: break;
	case MAPCODE_USEOK: map[n]=MAPCODE_USE; break;
	default: _asm { int 3 }
	}
}


//!   ,  
//! \param node  
//! \param seed     (     )
//! \param depth 
//! \result     
int Check(ref_type node,int *seed,int depth)
{
	int n,r,t;
	if(depth==tree_h) {
#ifdef LIST_VOID
		for(n=0; n<LIST_SIZE; n++) {
			if(node.plist->v[n]==LIST_VOID) break;
			if(node.plist->v[n]<0 || node.plist->v[n]>=CHECK_SIZE) _asm { int 3 }
			if(*seed<node.plist->v[n]) *seed=node.plist->v[n]; else _asm { int 3 }
		}
		if(tree_h && n<LIST_SIZE/2) _asm { int 3 }
#else
		if(tree_h && node.plist->count<LIST_SIZE/2) _asm { int 3 }
		for(n=0; n<node.plist->count; n++) {
			if(node.plist->v[n]<0 || node.plist->v[n]>=CHECK_SIZE) _asm { int 3 }
			if(*seed<node.plist->v[n]) *seed=node.plist->v[n]; else _asm { int 3 }
		}
#endif
		return node.plist->v[0];
	}
	r=-1;
#ifdef NODE_VOID
	for(n=0; n<NODE_SIZE; n++) {
		if(!node.pnode->arr[n].p.pnode) break;
		t=Check(node.pnode->arr[n].p,seed,depth+1);
		if(!n) r=t;
		if(node.pnode->arr[n].v!=t) _asm { int 3 }
	}
	if(depth && n<NODE_SIZE/2) _asm { int 3 }
#else
	if(depth && node.pnode->count<NODE_SIZE/2) _asm { int 3 }
	for(n=0; n<node.pnode->count; n++) {
		t=Check(node.pnode->arr[n].p,seed,depth+1);
		if(!n) r=t;
		if(node.pnode->arr[n].v!=t) _asm { int 3 }
	}
#endif
	return r;
}


//!   
//!          
//!       
//!          
//!   
void Check()
{
	int value=-99;
	Check(tree_root,&value,0);
}


//=============================================================================




void main()
{
	int n,v;
	Init();
	memset(map,MAPCODE_FREE,sizeof(map));
	for(n=0;;n++) 
	{
		printf("[pass: %d]\n",n);
		v=rand()%CHECK_SIZE; map[v]=MAPCODE_USE;  
		Insert(v);
		Check();
		CheckMap();
		v=rand()%CHECK_SIZE; map[v]=MAPCODE_FREE;
		Remove(v);
		if(!(n%5000)) Show();
		Check();
		CheckMap();
		if(_kbhit()) break;
	}
	//  
	printf("wipe teee\n");
	DropTree();
	printf("[done]\n");
	getchar();
	getchar();
}






